// transscrollView.cpp : implementation of the CTransscrollView class
//

#include "stdafx.h"
#include "transscroll.h"

#include "transscrollDoc.h"
#include "transscrollView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTransscrollView

IMPLEMENT_DYNCREATE(CTransscrollView, CScrollView)

BEGIN_MESSAGE_MAP(CTransscrollView, CScrollView)
	//{{AFX_MSG_MAP(CTransscrollView)
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTransscrollView construction/destruction

CTransscrollView::CTransscrollView()
{
	// TODO: add construction code here

}

CTransscrollView::~CTransscrollView()
{
}

BOOL CTransscrollView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return CScrollView::PreCreateWindow(cs);	
}

/////////////////////////////////////////////////////////////////////////////
// CTransscrollView drawing

void CTransscrollView::OnDraw(CDC* pDC)
{
	CTransscrollDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
	CFont *pOldFont;
	
	int ct;

	pDC->SetBkMode(TRANSPARENT);
	
	int start = GetDeviceScrollPosition().y /m_nLineHt -1;
	if (start < 0) start =0;

	CRect rcClient;

	GetClientRect(&rcClient);

	ct = start + rcClient.Height()/m_nLineHt + 3;

	if( ct > 25) ct=25;
	
	pOldFont = pDC->SelectObject(&m_ftTimes);
	
	pDC->SetTextColor(RGB(255,12,146));
	
	for(int i=start;i<ct;i++)
	{
		CString s;
		s.Format("I am line %d on a fixed background",i+1);
		pDC->TextOut(0,i * m_nLineHt,s);
	}
	
	pDC->SelectObject(pOldFont);

}

void CTransscrollView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = 500;
	sizeTotal.cy = 25 * m_nLineHt;
	SetScrollSizes(MM_TEXT, sizeTotal);	
}

/////////////////////////////////////////////////////////////////////////////
// CTransscrollView diagnostics

#ifdef _DEBUG
void CTransscrollView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CTransscrollView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CTransscrollDoc* CTransscrollView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTransscrollDoc)));
	return (CTransscrollDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTransscrollView message handlers

int CTransscrollView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CScrollView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	CClientDC dc(this);
	m_ftTimes.CreatePointFont(500,"Times New Roman",&dc);
	
	CFont *pOldFont;
	pOldFont = dc.SelectObject(&m_ftTimes);

	TEXTMETRIC tm;
	dc.GetTextMetrics(&tm);
	m_nLineHt = tm.tmHeight + tm.tmExternalLeading;

	dc.SelectObject(pOldFont);
	return 0;
}

BOOL CTransscrollView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	return TRUE;
	//return CScrollView::OnEraseBkgnd(pDC);
	
}
